import * as vue2_types_v3_component_options from 'vue2/types/v3-component-options';
import * as _visoning_vue_utility from '@visoning/vue-utility';
import * as _floating_ui_core_src_types from '@floating-ui/core/src/types';
import * as vue_demi from 'vue-demi';
import { PropType, UnwrapRef, ExtractPropTypes } from 'vue-demi';
import { R as ReferenceType, d as UseAutoUpdateOptions, e as UseFloatingData, F as FloatingType } from '../useAutoUpdate-9edcfe5f.js';
import { Placement, Strategy, Middleware } from '@floating-ui/core';
import '@floating-ui/dom';

declare const FloatingCreator: vue_demi.DefineComponent<_visoning_vue_utility.WithDefaultProps<{
    readonly reference: {
        type: vue_demi.PropType<ReferenceType | null>;
    };
    readonly floating: {
        type: vue_demi.PropType<HTMLElement | null>;
    };
    readonly disabled: BooleanConstructor;
    readonly placement: vue_demi.PropType<_floating_ui_core_src_types.Placement>;
    readonly strategy: vue_demi.PropType<_floating_ui_core_src_types.Strategy>;
    readonly middleware: vue_demi.PropType<_floating_ui_core_src_types.Middleware[]>;
    readonly autoUpdate: vue_demi.PropType<boolean | UseAutoUpdateOptions>;
    readonly onFloatingDataUpdate: vue_demi.PropType<(data: {
        x: number | null;
        y: number | null;
        strategy: _floating_ui_core_src_types.Strategy;
        placement: _floating_ui_core_src_types.Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number | undefined;
                y?: number | undefined;
                centerOffset: number;
            } | undefined;
            autoPlacement?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core_src_types.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            flip?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core_src_types.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            hide?: {
                referenceHidden?: boolean | undefined;
                escaped?: boolean | undefined;
                referenceHiddenOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
                escapedOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
            } | undefined;
            offset?: {
                x: number;
                y: number;
            } | undefined;
            shift?: {
                x: number;
                y: number;
            } | undefined;
        };
    }) => void>;
}, {
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>, () => vue_demi.VNode[] | undefined, {}, {}, {}, vue2_types_v3_component_options.ComponentOptionsMixin, vue2_types_v3_component_options.ComponentOptionsMixin, {}, string, Readonly<vue_demi.ExtractPropTypes<_visoning_vue_utility.WithDefaultProps<{
    readonly reference: {
        type: vue_demi.PropType<ReferenceType | null>;
    };
    readonly floating: {
        type: vue_demi.PropType<HTMLElement | null>;
    };
    readonly disabled: BooleanConstructor;
    readonly placement: vue_demi.PropType<_floating_ui_core_src_types.Placement>;
    readonly strategy: vue_demi.PropType<_floating_ui_core_src_types.Strategy>;
    readonly middleware: vue_demi.PropType<_floating_ui_core_src_types.Middleware[]>;
    readonly autoUpdate: vue_demi.PropType<boolean | UseAutoUpdateOptions>;
    readonly onFloatingDataUpdate: vue_demi.PropType<(data: {
        x: number | null;
        y: number | null;
        strategy: _floating_ui_core_src_types.Strategy;
        placement: _floating_ui_core_src_types.Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number | undefined;
                y?: number | undefined;
                centerOffset: number;
            } | undefined;
            autoPlacement?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core_src_types.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            flip?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core_src_types.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            hide?: {
                referenceHidden?: boolean | undefined;
                escaped?: boolean | undefined;
                referenceHiddenOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
                escapedOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
            } | undefined;
            offset?: {
                x: number;
                y: number;
            } | undefined;
            shift?: {
                x: number;
                y: number;
            } | undefined;
        };
    }) => void>;
}, {
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>>>, {
    readonly disabled: boolean;
    readonly placement: _floating_ui_core_src_types.Placement;
    readonly strategy: _floating_ui_core_src_types.Strategy;
    readonly autoUpdate: boolean | UseAutoUpdateOptions;
}>;

declare type FloatingData = UseFloatingData;
declare type AutoUpdateOptions = UseAutoUpdateOptions;
declare type FloatingCreatorSlotProps = FloatingData;
interface FloatingCreatorExposed {
    getFloatingData: () => FloatingData;
    updatePosition: () => void;
}
declare const FloatingCreatorPropsType: {
    /**
     * Reference element.
     *
     * You can position a floating element relative to a virtual element instead of a real one.
     * This enables things like positioning context menus or following the cursor.
     * @see https://floating-ui.com/docs/virtual-elements
     */
    readonly reference: {
        type: PropType<ReferenceType | null>;
    };
    /**
     * Floating element.
     */
    readonly floating: {
        type: PropType<FloatingType | null>;
    };
    /**
     * Whether to disable the floating.
     */
    readonly disabled: BooleanConstructor;
    /**
     * Where to place the floating element relative to its reference element.
     * @see https://floating-ui.com/docs/computePosition#placement
     *
     * @default 'bottom'
     */
    readonly placement: PropType<Placement>;
    /**
     * This is the type of CSS position property to use.
     * @see https://floating-ui.com/docs/computePosition#strategy
     *
     * @default 'absolute'
     */
    readonly strategy: PropType<Strategy>;
    /**
     * They alter the positioning coordinates from the basic placement to customize the position,
     * provide data, or act as "visibility optimization" techniques.
     * @see https://floating-ui.com/docs/computePosition#middleware
     */
    readonly middleware: PropType<Middleware[]>;
    /**
     * This function adds listeners that automatically call an update function when necessary
     * so that the floating element remains “anchored” to the reference element in a variety of scenarios without detaching.
     *
     * @default true
     */
    readonly autoUpdate: PropType<boolean | UseAutoUpdateOptions>;
    /**
     * Callback on floating data status changes.
     */
    readonly onFloatingDataUpdate: PropType<(data: UnwrapRef<FloatingData>) => void>;
};
declare const FloatingCreatorDefaultProps: {
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
};
declare const FloatingCreatorProps: _visoning_vue_utility.WithDefaultProps<{
    /**
     * Reference element.
     *
     * You can position a floating element relative to a virtual element instead of a real one.
     * This enables things like positioning context menus or following the cursor.
     * @see https://floating-ui.com/docs/virtual-elements
     */
    readonly reference: {
        type: PropType<ReferenceType | null>;
    };
    /**
     * Floating element.
     */
    readonly floating: {
        type: PropType<FloatingType | null>;
    };
    /**
     * Whether to disable the floating.
     */
    readonly disabled: BooleanConstructor;
    /**
     * Where to place the floating element relative to its reference element.
     * @see https://floating-ui.com/docs/computePosition#placement
     *
     * @default 'bottom'
     */
    readonly placement: PropType<Placement>;
    /**
     * This is the type of CSS position property to use.
     * @see https://floating-ui.com/docs/computePosition#strategy
     *
     * @default 'absolute'
     */
    readonly strategy: PropType<Strategy>;
    /**
     * They alter the positioning coordinates from the basic placement to customize the position,
     * provide data, or act as "visibility optimization" techniques.
     * @see https://floating-ui.com/docs/computePosition#middleware
     */
    readonly middleware: PropType<Middleware[]>;
    /**
     * This function adds listeners that automatically call an update function when necessary
     * so that the floating element remains “anchored” to the reference element in a variety of scenarios without detaching.
     *
     * @default true
     */
    readonly autoUpdate: PropType<boolean | UseAutoUpdateOptions>;
    /**
     * Callback on floating data status changes.
     */
    readonly onFloatingDataUpdate: PropType<(data: UnwrapRef<FloatingData>) => void>;
}, {
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>;
declare type FloatingCreatorProps = ExtractPropTypes<typeof FloatingCreatorProps>;

export { AutoUpdateOptions, FloatingCreator, FloatingCreatorDefaultProps, FloatingCreatorExposed, FloatingCreatorProps, FloatingCreatorPropsType, FloatingCreatorSlotProps, FloatingData };
